/*
  ( )
 ChatPainter.
 . . , 2002
  ,   
  -     
E-mail: super-m@narod.ru
Web: super-m.narod.ru
*/

#include <windows.h>
#include "chatpntr.h"
#include <stdio.h>
#include <stdlib.h>
//#include <io.h>

typedef struct{
   BYTE b;
   BYTE g;
   BYTE r;
} rgb_value; //RGB

/*******************  Global Variables ********************/

RGBQUAD bmp_table[256]; //bitmap palette
rgb_value **colors;
int I, J; //sizes of bitmap
HANDLE ghInstance;
HWND hwndStatic_input, hwndStatic_result;
HWND hwndEdit_input, hwndEdit_result, hwndEdit_log;
HWND hwndButtonInfo, hwndButtonBrowse, hwndButtonGo;

/*********************  Prototypes  ***********************/
LRESULT WINAPI MainWndProc( HWND, UINT, WPARAM, LPARAM );
bool ExtractBmp(char *path);
void alloc_all(int a_I, int a_J);
rgb_value rgb8(BYTE val);
rgb_value rgb16(WORD val);
rgb_value rgb32(DWORD val);
void dealloc_all(void);
void Convert(void);
void browseFile(void);


///********************************************************************
///*  Function: int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int)    *
///*                                                                    *
///*   Purpose: Initializes Application                                 *

///*  Comments: Register window class, create and display the main      *
///*            window, and enter message loop.                         *
///*                                                                    *
///********************************************************************/

int PASCAL WinMain( HINSTANCE hInstance,
    HINSTANCE hPrevInstance,

    LPSTR lpszCmdLine,
    int nCmdShow )
{
   WNDCLASS wc;
   MSG msg;
   HWND hWnd;

   if( !hPrevInstance )
   {
      wc.lpszClassName = "ChatpntrAppClass";
      wc.lpfnWndProc = MainWndProc;
      wc.style = CS_OWNDC;
      wc.hInstance = hInstance;
      wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_CHATPNTRICON) );
      wc.hCursor = LoadCursor( hInstance, MAKEINTRESOURCE(IDC_CHATPNTRCURSOR) );
      wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE+1 );
      wc.lpszMenuName = /*"GenericAppMenu"*/NULL;

      wc.cbClsExtra = 0;
      wc.cbWndExtra = 0;

      RegisterClass( &wc );
   }

   ghInstance = hInstance;

   hWnd = CreateWindow( "ChatpntrAppClass",
      "ChatPainter",
      WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
      0,
      0,
      500,
      400,
      NULL,
      NULL,
      hInstance,
      NULL
   );

   ShowWindow( hWnd, nCmdShow );

   while( GetMessage( &msg, NULL, 0, 0 ) ) {
      TranslateMessage( &msg );

      DispatchMessage( &msg );
   }

   return msg.wParam;
}

///********************************************************************
///* Function: LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM) *
///*                                                                    *
///*  Purpose: Processes Application Messages                           *
///*                                                                    *
///* Comments: The following messages are processed                     *

///*           WM_COMMAND                                               *
///*           WM_CREATE                                                *
///*           WM_DESTROY                                               *
///*                                                                    *
///********************************************************************/

LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wParam,
   LPARAM lParam )
{
   HDC hDC;
   WORD wNotifyCode, wID;
   char local_buf[1024];
   wNotifyCode = HIWORD(wParam); // notification code
   wID = LOWORD(wParam);

   switch( msg ) {

      case WM_CREATE:
         hwndStatic_input = CreateWindow(
                "STATIC",     /* predefined class  */
                ":",       /*  window title  */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 10, 50, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_STATIC1, /* control ID  */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_input = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT |
                 ES_AUTOHSCROLL | WS_DLGFRAME,
                70, 10, 300, 20, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITINPUT, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndStatic_result = CreateWindow(
                "STATIC",     /* predefined class                  */
                "    :", /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 70, 220, 20, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_result = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT |
                 ES_READONLY | ES_MULTILINE |  ES_AUTOVSCROLL | WS_VSCROLL |
                 WS_DLGFRAME,
                10, 100, 480, 200, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITRESULT, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndEdit_log = CreateWindow(
                "EDIT",     /* predefined class  */
                NULL,       /* no window title  */
                WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_LEFT |
                 ES_READONLY | ES_MULTILINE |  ES_AUTOVSCROLL |
                 ES_WANTRETURN | WS_VSCROLL,
                10, 310, 370, 50, /* set size  */
                hWnd,       /* parent window  */
                (HMENU) ID_EDITLOG, /* edit control ID */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndButtonInfo = CreateWindow(
                "BUTTON",     /* predefined class                  */
                " ",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                 BS_CENTER | BS_VCENTER,
                200, 35, 90, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON1, /* control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndButtonBrowse = CreateWindow(
                "BUTTON",     /* predefined class                  */
                "...",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                 BS_CENTER | BS_VCENTER,
                380, 10, 50, 20, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON2, /* control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         hwndButtonGo = CreateWindow(
                "BUTTON",     /* predefined class                  */
                "!",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                 BS_CENTER | BS_VCENTER,
                70, 35, 100, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON3, /* control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         break;
//     WM_COMMAND:

      case WM_COMMAND:
         if (wNotifyCode==BN_CLICKED)
         {
           switch( wID )
           {
            case ID_BUTTON1:
               MessageBox( hWnd,
                 " \n"
                 " html   .\n 0.1  "__DATE__"\n"
                 "  Super-M\n(. . )\n"
                 "E-mail: super-m@narod.ru\n"
                 ": super-m.narod.ru",
                 "  ChatPainter",
                 MB_OK | MB_ICONASTERISK );
            break;
            case ID_BUTTON2:
               browseFile();
            break;
            case ID_BUTTON3:
               GetWindowText(hwndEdit_input, local_buf, 1024);
               if (ExtractBmp(local_buf))
               {
                 Convert();
                 dealloc_all();
               }//end if
               else
               {
                 MessageBox( hWnd,
                  "   ",
                  "",
                  MB_OK | MB_ICONWARNING );
               }//end else
            break;
           }//end switch
         }//end if
      break;


//     WM_DESTROY: PostQuitMessage() is called

      case WM_DESTROY:
         PostQuitMessage( 0 );
         break;

//     Let the default window proc handle all other messages

      default:
         return( DefWindowProc( hWnd, msg, wParam, lParam ));

   }

   return 0;
}//end MainWndProc

bool ExtractBmp(char *path)
{

/*#define BI_RGB        0L

#define BI_RLE8       1L
#define BI_RLE4       2L
#define BI_BITFIELDS  3L*/
FILE *in;

int ii, jj, num, bmp_I, bmp_J;
unsigned char mass[256]/*, the_pix*/;
unsigned long l_tmp, size, offset;
BITMAPINFOHEADER b_i_h;
bool res=true, allok=true;
BYTE buf8;
WORD buf16;
rgb_value buf24;
DWORD buf32;
char log_buf[1024], log_out_buf[4096];
int BytesAllLine, BytesLinePixs, BytesLineIdle;

lstrcpy(log_out_buf, "");

in=fopen(path, "rb");
res=(in!=NULL);
if (res)
{
   num=fread(mass, 1, 2, in); //BM
   if ((num==2) && (mass[0]=='B') && (mass[1]=='M'))
   {
      //printf(": %d\r\n", num);
      fread(&size, 4, 1, in); //read file size
      fread(&l_tmp, 4, 1, in); //reserved
      fread(&offset, 4, 1, in); //offset of bmp data
      //BITMAPFILEHEADER finished
      fread(&b_i_h, sizeof(BITMAPINFOHEADER), 1, in);
      //BITMAPINFOHEADER got
      bmp_I=b_i_h.biWidth;
      bmp_J=abs(b_i_h.biHeight);
      if ((b_i_h.biBitCount!=8) && (b_i_h.biBitCount!=16) &&
          (b_i_h.biBitCount!=24) && (b_i_h.biBitCount!=32))
      {
         sprintf(log_buf, "   %ld  (%d ).\r\n"
         "  \r\n"
         " 8-, 16-, 24-  32- \r\n",
         (1L<<b_i_h.biBitCount), b_i_h.biBitCount);
         lstrcat(log_out_buf, log_buf);
      }
      if ((b_i_h.biCompression!=BI_RGB) &&
          (b_i_h.biCompression!=BI_BITFIELDS))
      {
         sprintf(log_buf, "a a  .\r\n"
         "  "
         "   \r\n");
         lstrcat(log_out_buf, log_buf);
      }
      res=res && ((b_i_h.biBitCount==8) ||
        (b_i_h.biBitCount==16) || (b_i_h.biBitCount==24) ||
        (b_i_h.biBitCount==32));
      res=res && ((b_i_h.biCompression==BI_RGB) ||
         (b_i_h.biCompression==BI_BITFIELDS));
      res=res && (b_i_h.biPlanes==1);
      if (res)
      {
         //num of pixel bytes in scan line
         BytesLinePixs=(int)(b_i_h.biBitCount>>3)*
            (int)b_i_h.biWidth;
         //num of all bytes in scan line
         //must be divisable by 4
         BytesAllLine=(BytesLinePixs+3)&0xfffc;
         BytesLineIdle=BytesAllLine-BytesLinePixs;
         if (b_i_h.biBitCount==8) //need color table
            fread(&bmp_table, sizeof(RGBQUAD), 256, in);
         fseek(in, offset, SEEK_SET);
         alloc_all(bmp_I, bmp_J);
         if (b_i_h.biHeight<0)
         { //top-down bmp
            sprintf(log_buf, "Top-down bitmap\r\n");
            lstrcat(log_out_buf, log_buf);
            for (jj=0; (jj<bmp_J)&&allok; jj++)
            { //rows
               for (ii=0; (ii<bmp_I)&&allok; ii++)
               { //cols
                  switch (b_i_h.biBitCount)
                  {
                  case 8:
                   allok=(fread(&buf8, 1, 1, in)==1);
                     buf24=rgb8(buf8);
                  break;
                  case 16:
                   allok=(fread(&buf16, 2, 1, in)==1);
                   buf24=rgb16(buf16);
                  break;
                  case 24:
                   allok=(fread(&buf24, 3, 1, in)==1);
                  break;
                  case 32:
                   allok=(fread(&buf32, 4, 1, in)==1);
                   buf24=rgb32(buf32);
                  break;
                  }//end switch ()
                  colors[ii][jj]=buf24;
               }//end for ii
               if (BytesLineIdle>0)
                  fread(mass, 1, BytesLineIdle, in);
            }//end for jj
         }//if-else (top-down bmp)
         else
         { //bottom-up bmp
            sprintf(log_buf, "Bottom-up bitmap\r\n");
            lstrcat(log_out_buf, log_buf);
            for (jj=bmp_J-1; (jj>=0)&&allok; jj--)
            { //rows
               for (ii=0; (ii<bmp_I)&&allok; ii++)
               { //cols
                  switch (b_i_h.biBitCount)
                  {
                  case 8:
                   allok=(fread(&buf8, 1, 1, in)==1);
                     buf24=rgb8(buf8);
                  break;
                  case 16:
                   allok=(fread(&buf16, 2, 1, in)==1);
                   buf24=rgb16(buf16);
                  break;
                  case 24:
                   allok=(fread(&buf24, 3, 1, in)==1);
                  break;
                  case 32:
                   allok=(fread(&buf32, 4, 1, in)==1);
                   buf24=rgb32(buf32);
                  break;
                  }//end switch ()
                  colors[ii][jj]=buf24;
               }//end for ii
               if (BytesLineIdle>0)
                  fread(mass, 1, BytesLineIdle, in);
            }//end for jj
         }//end else (bottom-up bmp)
      }//end if
      sprintf(log_buf, "   %s:\r\n %d  %d\r\n"
      "  %ld\r\n   %ld /\r\n"
      "   %ld /\r\n biClrUsed "
      "%ld\r\n biClrImportant %ld\r\n",
      path, bmp_I, bmp_J, (1L<<b_i_h.biBitCount),
      b_i_h.biXPelsPerMeter, b_i_h.biYPelsPerMeter,
      b_i_h.biClrUsed, b_i_h.biClrImportant);
      lstrcat(log_out_buf, log_buf);
   }//end if
   fclose(in);
}//end if
if (!res)
{
   bmp_I=5; bmp_J=5; alloc_all(bmp_I, bmp_J);
   sprintf(log_buf, "The suck!   \r\n"
   " - !\r\n");
   lstrcat(log_out_buf, log_buf);
}//end if
if (!allok)
{
   sprintf(log_buf, "Thunderfucker!!!  %s \r\n"
   " !   uf?! (?)\r\n",
   path);
   lstrcat(log_out_buf, log_buf);
}//end if
I=bmp_I; J=bmp_J;
SetWindowText(hwndEdit_log, log_out_buf);
return res;

}//end ExtractBmp
//-----------------------------------------------------


void alloc_all(int a_I, int a_J)
{

int a_i;

//initializing arrays of pixel colors:
colors=(rgb_value **) malloc( a_I * sizeof(rgb_value *) );
for (a_i=0; a_i<a_I; a_i++)
  colors[a_i]=(rgb_value*) malloc( a_J * sizeof(rgb_value) );
//array of colors inited

}//end alloc_all
//-----------------------------------------------------

rgb_value rgb8(BYTE val)
{

rgb_value ret;
ret.r=bmp_table[val].rgbRed;
ret.g=bmp_table[val].rgbGreen;
ret.b=bmp_table[val].rgbBlue;

return ret;

}//end rgb8
//-----------------------------------------------------

rgb_value rgb16(WORD val)
{

rgb_value ret;

ret.b=val & 0x001f;

ret.g=(val & 0x03e0)>>5;

ret.r=(val & 0x7c00)>>10;

ret.b<<=3;

ret.g<<=3;

ret.r<<=3;

return ret;

}//end rgb16
//-----------------------------------------------------

rgb_value rgb32(DWORD val)
{

rgb_value ret;

ret.b=val & 0x000000ffL;

ret.g=(val & 0x0000ff00L)>>8;

ret.r=(val & 0x00ff0000L)>>16;

return ret;

}//end rgb32
//-----------------------------------------------------
void dealloc_all(void)
{
int a_i;
//deinitializing arrays of pixel colors:
for (a_i=0; a_i<I; a_i++)
  free(colors[a_i]);
free(colors);
//array of colors freed
}//end dealloc_all
//-----------------------------------
void Convert(void)
{
//<font face='Webdings'><font size='4'></font></font>
//<font color='#000000'>c</font>
//<br>
char *buffer, tmpbuf[256];
int bufsize, i, j;
bufsize=55+(I*J)*30+J*4;
buffer = new char [bufsize]; //alloc buf
sprintf(buffer, "<br><font face='Webdings'><font size='4'>");
for (j=0; j<J; j++)
{
 for (i=0; i<I; i++)
 {
   sprintf(tmpbuf, "<font color='#%02X%02X%02X'>g</font>",
     colors[i][j].r, colors[i][j].g, colors[i][j].b);
   lstrcat(buffer, tmpbuf);
 }//end for i
 sprintf(tmpbuf, "<br>"); lstrcat(buffer, tmpbuf);
}//end for j
sprintf(tmpbuf, "</font></font>");
lstrcat(buffer, tmpbuf);
SetWindowText(hwndEdit_result, buffer);
delete buffer; //dealloc buf
}//end Convert
//-----------------------------------

void browseFile(void)
{
  char pathbuf[1024];
  OPENFILENAME open_opts;
  lstrcpy(pathbuf, "\0");
  open_opts.lStructSize=sizeof(OPENFILENAME);
  open_opts.hwndOwner=NULL;
  open_opts.lpstrFilter=" Windows BMP\0*.bmp\0\0";
  open_opts.lpstrCustomFilter=NULL;
  open_opts.lpstrFile=pathbuf;
  open_opts.nMaxFile=1024;
  open_opts.lpstrFileTitle=NULL;
  open_opts.lpstrInitialDir=NULL;
  open_opts.lpstrTitle=" ";
  open_opts.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |
   OFN_PATHMUSTEXIST;
  open_opts.lpstrDefExt="bmp";
  if (GetOpenFileName(&open_opts))
  {
     SetWindowText(hwndEdit_input, pathbuf);
  }//end if
}//end browseFile